<!DOCTYPE html>

<html>
  <head>
    <title>Protocol Documentation</title>
    <meta charset="UTF-8">
    <link rel="stylesheet" type="text/css" href="https://fonts.googleapis.com/css?family=Ubuntu:400,700,400italic"/>
    <style>
      body {
        width: 60em;
        margin: 1em auto;
        color: #222;
        font-family: "Ubuntu", sans-serif;
        padding-bottom: 4em;
      }

      h1 {
        font-weight: normal;
        border-bottom: 1px solid #aaa;
        padding-bottom: 0.5ex;
      }

      h2 {
        border-bottom: 1px solid #aaa;
        padding-bottom: 0.5ex;
        margin: 1.5em 0;
      }

      h3 {
        font-weight: normal;
        border-bottom: 1px solid #aaa;
        padding-bottom: 0.5ex;
      }

      a {
        text-decoration: none;
        color: #567e25;
      }

      table {
        width: 100%;
        font-size: 80%;
        border-collapse: collapse;
      }

      thead {
        font-weight: 700;
        background-color: #dcdcdc;
      }

      tbody tr:nth-child(even) {
        background-color: #fbfbfb;
      }

      td {
        border: 1px solid #ccc;
        padding: 0.5ex 2ex;
      }

      td p {
        text-indent: 1em;
        margin: 0;
      }

      td p:nth-child(1) {
        text-indent: 0;  
      }

       
      .field-table td:nth-child(1) {  
        width: 10em;
      }
      .field-table td:nth-child(2) {  
        width: 10em;
      }
      .field-table td:nth-child(3) {  
        width: 6em;
      }
      .field-table td:nth-child(4) {  
        width: auto;
      }

       
      .extension-table td:nth-child(1) {  
        width: 10em;
      }
      .extension-table td:nth-child(2) {  
        width: 10em;
      }
      .extension-table td:nth-child(3) {  
        width: 10em;
      }
      .extension-table td:nth-child(4) {  
        width: 5em;
      }
      .extension-table td:nth-child(5) {  
        width: auto;
      }

       
      .enum-table td:nth-child(1) {  
        width: 10em;
      }
      .enum-table td:nth-child(2) {  
        width: 10em;
      }
      .enum-table td:nth-child(3) {  
        width: auto;
      }

       
      .scalar-value-types-table tr {
        height: 3em;
      }

       
      #toc-container ul {
        list-style-type: none;
        padding-left: 1em;
        line-height: 180%;
        margin: 0;
      }
      #toc > li > a {
        font-weight: bold;
      }

       
      .file-heading {
        width: 100%;
        display: table;
        border-bottom: 1px solid #aaa;
        margin: 4em 0 1.5em 0;
      }
      .file-heading h2 {
        border: none;
        display: table-cell;
      }
      .file-heading a {
        text-align: right;
        display: table-cell;
      }

       
      .badge {
        width: 1.6em;
        height: 1.6em;
        display: inline-block;

        line-height: 1.6em;
        text-align: center;
        font-weight: bold;
        font-size: 60%;

        color: #89ba48;
        background-color: #dff0c8;

        margin: 0.5ex 1em 0.5ex -1em;
        border: 1px solid #fbfbfb;
        border-radius: 1ex;
      }
    </style>

    
    <link rel="stylesheet" type="text/css" href="stylesheet.css"/>
  </head>

  <body>

    <h1 id="title">Protocol Documentation</h1>

    <h2>Table of Contents</h2>

    <div id="toc-container">
      <ul id="toc">
        
          
          <li>
            <a href="#iam.proto">iam.proto</a>
            <ul>
              
                <li>
                  <a href="#grpc.iam.v1.Array2DReply"><span class="badge">M</span>Array2DReply</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.Array2DReply.d"><span class="badge">M</span>Array2DReply.d</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.ArrayReply"><span class="badge">M</span>ArrayReply</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.BoolReply"><span class="badge">M</span>BoolReply</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.EmptyReply"><span class="badge">M</span>EmptyReply</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.EmptyRequest"><span class="badge">M</span>EmptyRequest</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.EnforceRequest"><span class="badge">M</span>EnforceRequest</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.FilteredPolicyRequest"><span class="badge">M</span>FilteredPolicyRequest</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.NewAdapterReply"><span class="badge">M</span>NewAdapterReply</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.NewAdapterRequest"><span class="badge">M</span>NewAdapterRequest</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.NewEnforcerReply"><span class="badge">M</span>NewEnforcerReply</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.NewEnforcerRequest"><span class="badge">M</span>NewEnforcerRequest</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.PermissionRequest"><span class="badge">M</span>PermissionRequest</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.PolicyRequest"><span class="badge">M</span>PolicyRequest</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.SimpleGetRequest"><span class="badge">M</span>SimpleGetRequest</a>
                </li>
              
                <li>
                  <a href="#grpc.iam.v1.UserRoleRequest"><span class="badge">M</span>UserRoleRequest</a>
                </li>
              
              
              
              
                <li>
                  <a href="#grpc.iam.v1.Iam"><span class="badge">S</span>Iam</a>
                </li>
              
            </ul>
          </li>
        
        <li><a href="#scalar-value-types">Scalar Value Types</a></li>
      </ul>
    </div>

    
      
      <div class="file-heading">
        <h2 id="iam.proto">iam.proto</h2><a href="#title">Top</a>
      </div>
      <p></p>

      
        <h3 id="grpc.iam.v1.Array2DReply">Array2DReply</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>d2</td>
                  <td><a href="#grpc.iam.v1.Array2DReply.d">Array2DReply.d</a></td>
                  <td>repeated</td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.Array2DReply.d">Array2DReply.d</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>d1</td>
                  <td><a href="#string">string</a></td>
                  <td>repeated</td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.ArrayReply">ArrayReply</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>array</td>
                  <td><a href="#string">string</a></td>
                  <td>repeated</td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.BoolReply">BoolReply</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>res</td>
                  <td><a href="#bool">bool</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.EmptyReply">EmptyReply</h3>
        <p></p>

        

        
      
        <h3 id="grpc.iam.v1.EmptyRequest">EmptyRequest</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>handler</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.EnforceRequest">EnforceRequest</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>enforcerHandler</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>params</td>
                  <td><a href="#string">string</a></td>
                  <td>repeated</td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.FilteredPolicyRequest">FilteredPolicyRequest</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>enforcerHandler</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>pType</td>
                  <td><a href="#string">string</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>fieldIndex</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>fieldValues</td>
                  <td><a href="#string">string</a></td>
                  <td>repeated</td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.NewAdapterReply">NewAdapterReply</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>handler</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.NewAdapterRequest">NewAdapterRequest</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>adapterName</td>
                  <td><a href="#string">string</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>driverName</td>
                  <td><a href="#string">string</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>connectString</td>
                  <td><a href="#string">string</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>dbSpecified</td>
                  <td><a href="#bool">bool</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.NewEnforcerReply">NewEnforcerReply</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>handler</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.NewEnforcerRequest">NewEnforcerRequest</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>modelText</td>
                  <td><a href="#string">string</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>adapterHandle</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.PermissionRequest">PermissionRequest</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>enforcerHandler</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>user</td>
                  <td><a href="#string">string</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>permissions</td>
                  <td><a href="#string">string</a></td>
                  <td>repeated</td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.PolicyRequest">PolicyRequest</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>enforcerHandler</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>pType</td>
                  <td><a href="#string">string</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>params</td>
                  <td><a href="#string">string</a></td>
                  <td>repeated</td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.SimpleGetRequest">SimpleGetRequest</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>enforcerHandler</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>pType</td>
                  <td><a href="#string">string</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      
        <h3 id="grpc.iam.v1.UserRoleRequest">UserRoleRequest</h3>
        <p></p>

        
          <table class="field-table">
            <thead>
              <tr><td>Field</td><td>Type</td><td>Label</td><td>Description</td></tr>
            </thead>
            <tbody>
              
                <tr>
                  <td>enforcerHandler</td>
                  <td><a href="#int32">int32</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>user</td>
                  <td><a href="#string">string</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
                <tr>
                  <td>role</td>
                  <td><a href="#string">string</a></td>
                  <td></td>
                  <td><p> </p></td>
                </tr>
              
            </tbody>
          </table>

          

        
      

      

      

      
        <h3 id="grpc.iam.v1.Iam">Iam</h3>
        <p>The Casbin service definition.</p>
        <table class="enum-table">
          <thead>
            <tr><td>Method Name</td><td>Request Type</td><td>Response Type</td><td>Description</td></tr>
          </thead>
          <tbody>
            
              <tr>
                <td>NewEnforcer</td>
                <td><a href="#grpc.iam.v1.NewEnforcerRequest">NewEnforcerRequest</a></td>
                <td><a href="#grpc.iam.v1.NewEnforcerReply">NewEnforcerReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>NewAdapter</td>
                <td><a href="#grpc.iam.v1.NewAdapterRequest">NewAdapterRequest</a></td>
                <td><a href="#grpc.iam.v1.NewAdapterReply">NewAdapterReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>Enforce</td>
                <td><a href="#grpc.iam.v1.EnforceRequest">EnforceRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>LoadPolicy</td>
                <td><a href="#grpc.iam.v1.EmptyRequest">EmptyRequest</a></td>
                <td><a href="#grpc.iam.v1.EmptyReply">EmptyReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>SavePolicy</td>
                <td><a href="#grpc.iam.v1.EmptyRequest">EmptyRequest</a></td>
                <td><a href="#grpc.iam.v1.EmptyReply">EmptyReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>AddPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>AddNamedPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>RemovePolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>RemoveNamedPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>RemoveFilteredPolicy</td>
                <td><a href="#grpc.iam.v1.FilteredPolicyRequest">FilteredPolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>RemoveFilteredNamedPolicy</td>
                <td><a href="#grpc.iam.v1.FilteredPolicyRequest">FilteredPolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetPolicy</td>
                <td><a href="#grpc.iam.v1.EmptyRequest">EmptyRequest</a></td>
                <td><a href="#grpc.iam.v1.Array2DReply">Array2DReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetNamedPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.Array2DReply">Array2DReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetFilteredPolicy</td>
                <td><a href="#grpc.iam.v1.FilteredPolicyRequest">FilteredPolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.Array2DReply">Array2DReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetFilteredNamedPolicy</td>
                <td><a href="#grpc.iam.v1.FilteredPolicyRequest">FilteredPolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.Array2DReply">Array2DReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>AddGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>AddNamedGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>RemoveGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>RemoveNamedGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>RemoveFilteredGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.FilteredPolicyRequest">FilteredPolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>RemoveFilteredNamedGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.FilteredPolicyRequest">FilteredPolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.EmptyRequest">EmptyRequest</a></td>
                <td><a href="#grpc.iam.v1.Array2DReply">Array2DReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetNamedGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.Array2DReply">Array2DReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetFilteredGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.FilteredPolicyRequest">FilteredPolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.Array2DReply">Array2DReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetFilteredNamedGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.FilteredPolicyRequest">FilteredPolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.Array2DReply">Array2DReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetAllSubjects</td>
                <td><a href="#grpc.iam.v1.EmptyRequest">EmptyRequest</a></td>
                <td><a href="#grpc.iam.v1.ArrayReply">ArrayReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetAllNamedSubjects</td>
                <td><a href="#grpc.iam.v1.SimpleGetRequest">SimpleGetRequest</a></td>
                <td><a href="#grpc.iam.v1.ArrayReply">ArrayReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetAllObjects</td>
                <td><a href="#grpc.iam.v1.EmptyRequest">EmptyRequest</a></td>
                <td><a href="#grpc.iam.v1.ArrayReply">ArrayReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetAllNamedObjects</td>
                <td><a href="#grpc.iam.v1.SimpleGetRequest">SimpleGetRequest</a></td>
                <td><a href="#grpc.iam.v1.ArrayReply">ArrayReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetAllActions</td>
                <td><a href="#grpc.iam.v1.EmptyRequest">EmptyRequest</a></td>
                <td><a href="#grpc.iam.v1.ArrayReply">ArrayReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetAllNamedActions</td>
                <td><a href="#grpc.iam.v1.SimpleGetRequest">SimpleGetRequest</a></td>
                <td><a href="#grpc.iam.v1.ArrayReply">ArrayReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetAllRoles</td>
                <td><a href="#grpc.iam.v1.EmptyRequest">EmptyRequest</a></td>
                <td><a href="#grpc.iam.v1.ArrayReply">ArrayReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>GetAllNamedRoles</td>
                <td><a href="#grpc.iam.v1.SimpleGetRequest">SimpleGetRequest</a></td>
                <td><a href="#grpc.iam.v1.ArrayReply">ArrayReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>HasPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>HasNamedPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>HasGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
              <tr>
                <td>HasNamedGroupingPolicy</td>
                <td><a href="#grpc.iam.v1.PolicyRequest">PolicyRequest</a></td>
                <td><a href="#grpc.iam.v1.BoolReply">BoolReply</a></td>
                <td><p></p></td>
              </tr>
            
          </tbody>
        </table>

        
    

    <h2 id="scalar-value-types">Scalar Value Types</h2>
    <table class="scalar-value-types-table">
      <thead>
        <tr><td>.proto Type</td><td>Notes</td><td>C++ Type</td><td>Java Type</td><td>Python Type</td></tr>
      </thead>
      <tbody>
        
          <tr id="double">
            <td>double</td>
            <td></td>
            <td>double</td>
            <td>double</td>
            <td>float</td>
          </tr>
        
          <tr id="float">
            <td>float</td>
            <td></td>
            <td>float</td>
            <td>float</td>
            <td>float</td>
          </tr>
        
          <tr id="int32">
            <td>int32</td>
            <td>Uses variable-length encoding. Inefficient for encoding negative numbers – if your field is likely to have negative values, use sint32 instead.</td>
            <td>int32</td>
            <td>int</td>
            <td>int</td>
          </tr>
        
          <tr id="int64">
            <td>int64</td>
            <td>Uses variable-length encoding. Inefficient for encoding negative numbers – if your field is likely to have negative values, use sint64 instead.</td>
            <td>int64</td>
            <td>long</td>
            <td>int/long</td>
          </tr>
        
          <tr id="uint32">
            <td>uint32</td>
            <td>Uses variable-length encoding.</td>
            <td>uint32</td>
            <td>int</td>
            <td>int/long</td>
          </tr>
        
          <tr id="uint64">
            <td>uint64</td>
            <td>Uses variable-length encoding.</td>
            <td>uint64</td>
            <td>long</td>
            <td>int/long</td>
          </tr>
        
          <tr id="sint32">
            <td>sint32</td>
            <td>Uses variable-length encoding. Signed int value. These more efficiently encode negative numbers than regular int32s.</td>
            <td>int32</td>
            <td>int</td>
            <td>int</td>
          </tr>
        
          <tr id="sint64">
            <td>sint64</td>
            <td>Uses variable-length encoding. Signed int value. These more efficiently encode negative numbers than regular int64s.</td>
            <td>int64</td>
            <td>long</td>
            <td>int/long</td>
          </tr>
        
          <tr id="fixed32">
            <td>fixed32</td>
            <td>Always four bytes. More efficient than uint32 if values are often greater than 2^28.</td>
            <td>uint32</td>
            <td>int</td>
            <td>int</td>
          </tr>
        
          <tr id="fixed64">
            <td>fixed64</td>
            <td>Always eight bytes. More efficient than uint64 if values are often greater than 2^56.</td>
            <td>uint64</td>
            <td>long</td>
            <td>int/long</td>
          </tr>
        
          <tr id="sfixed32">
            <td>sfixed32</td>
            <td>Always four bytes.</td>
            <td>int32</td>
            <td>int</td>
            <td>int</td>
          </tr>
        
          <tr id="sfixed64">
            <td>sfixed64</td>
            <td>Always eight bytes.</td>
            <td>int64</td>
            <td>long</td>
            <td>int/long</td>
          </tr>
        
          <tr id="bool">
            <td>bool</td>
            <td></td>
            <td>bool</td>
            <td>boolean</td>
            <td>boolean</td>
          </tr>
        
          <tr id="string">
            <td>string</td>
            <td>A string must always contain UTF-8 encoded or 7-bit ASCII text.</td>
            <td>string</td>
            <td>String</td>
            <td>str/unicode</td>
          </tr>
        
          <tr id="bytes">
            <td>bytes</td>
            <td>May contain any arbitrary sequence of bytes.</td>
            <td>string</td>
            <td>ByteString</td>
            <td>str</td>
          </tr>
        
      </tbody>
    </table>
  </body>
</html>

